function ydot = therm(t,y,p)

Tgo=y(1);
Tgi=y(2);
Tw=y(3);
%dist=y(4);
vel= y(5);

ydot=[0;0;0;0;0];

% Derivative calculations

ydot(1)= ((p.h_air*p.A_out)/(p.m_g*p.c_g))*(p.Ta-Tgo);     % Derivative of Tgi
ydot(2)= ((p.k_glass*p.A_glass)/(p.m_g*p.c_g))*(Tgo-Tgi);  % Derivative of Tgo
ydot(3)= ((p.h_gw*p.A_in)/(p.m_w*p.c_w))*(Tgi-Tw);

% ydot(4)= velocity
ydot(4)=y(5);

% ydot(5) is derivative of velocity; acceleration.

%        m_b*acc = -6*pi*R*mu*vel + rho*vol*g- m_b*g';
%  acc= -6*pi*R*mu*vel/m_b + ((-0.0036)*(Tw)^2 + 1.8837*(Tw) + 752.67)*vol*g/m_b- *g;

%Acceleration with :
%   rho and mu as constants:
%ydot(5)= (-6*pi*p.R*p.mu/p.m_b)*vel + (p.rho*p.vol*p.g)/p.m_b - p.g;

%   rho as a function of Tw, mu as a constant:
%ydot(5)=-(6*pi*p.R*p.mu*vel)/p.m_b + ( (-0.0036)*(Tw)^2 + 1.8837*(Tw) + 752.67 )*p.vol*p.g/p.m_b - p.g;

%   rho and mu as functions of Tw:
ydot(5)=-(6*pi*p.R*((-3*10^-9)*Tw^3 + (3*10^-6)*Tw^2 - 0.001*Tw+0.1117)*vel)/p.m_b + ((-0.0036)*(Tw)^2 + 1.8837*(Tw) + 752.67)*p.vol*p.g/p.m_b - p.g;

